<template>
  <div class="flex flex-col h-full">
    <PageHeader
      :loading="isLoading"
      @refresh="onPageRefresh"
    />

    <Viewport
      :loading="isPaginationLoading"
      @fully-scrolled="onFullyScrolled"
    >
      <BookingsFilters
        :loading="isLoading"
        @apply="onFiltersApply"
      />

      <BookingsListSkeleton v-if="isLoading" />
      <EmptyState v-if="!isLoading && !bookingsStore.bookings.length" />

      <Container
        v-if="!isLoading || bookingsStore.bookings.length"
        class="!p-0 mt-2"
      >
        <v-timeline
          class="[&_.v-timeline-divider\_\_dot]:mt-[8px] py-8"
          density="comfortable"
          align="start"
          side="end"
          dot-color="grey"
          size="20"
          truncate-line="both"
          fill-dot
          hide-opposite
        >
          <template
            v-for="(booking, index) in bookingsStore.bookings"
            :key="booking.id"
          >
            <v-timeline-item
              v-if="todayMarkIndex === index"
              width="100%"
              side="end"
              class="[&_.v-timeline-item\_\_body]:!px-6"
              hide-dot
            >
              <section class="flex justify-center py-6 text-xl text-center border-2 border-dashed border-gray-300 text-gray-500 font-light tracking-lighter">
                <section class="flex items-start justify-end flex-auto">
                  <v-icon
                    icon="mdi-arrow-up-left"
                    class="pb-4 text-gray-400"
                  />
                </section>

                <section class="flex flex-col gap-2 flex-initial">
                  <section>Будущие</section>

                  <section class="text-gray-400">
                    <v-icon icon="mdi-calendar-star" />
                  </section>

                  <section>
                    Прошлые
                  </section>
                </section>

                <section class="flex items-end justify-start flex-auto">
                  <v-icon
                    icon="mdi-arrow-down-right"
                    class="pt-4 text-gray-400"
                  />
                </section>

                <section />
              </section>
            </v-timeline-item>

            <v-timeline-item
              :dot-color="booking.property.color"
              width="100%"
              side="end"
              class="[&_.v-timeline-item\_\_body]:!px-6"
            >
              <section class="block md:flex pb-8">
                <section class="flex-auto">
                  <section class="block md:flex items-center">
                    <section class="text-xl font-light mr-4 max-w-[300px] truncate">
                      {{ booking.property.name }}
                    </section>

                    <section class="mt-1 md:mt-0">
                      <BookingStatusDisplay :value="booking.status" />
                    </section>
                  </section>

                  <section class="pt-2 text-gray-500">
                    <b>{{ booking.guest.name }}</b> на
                    {{ getLabeledNightsCount(booking) }}
                  </section>

                  <section class="pt-1 text-gray-500">
                    {{ dt.display(booking.startDate, 'd MMMM') }} -
                    {{ dt.display(booking.endDate, 'd MMMM') }}
                  </section>
                </section>

                <section class="flex justify-start md:justify-center">
                  <v-btn
                    text="Подробнее"
                    variant="outlined"
                    class="text-teal-600 border-teal-600 mt-4 md:mt-0"
                    append-icon="mdi-open-in-new"
                    rounded
                    @click="$router.push(`/bookings/${booking.id}`)"
                  />
                </section>
              </section>

              <v-divider
                thickness="1"
                class="border-gray-800"
              />
            </v-timeline-item>

            <v-timeline-item
              v-if="todayMarkIndex === -1 && index === bookingsStore.bookings.length - 1"
              width="100%"
              side="end"
              class="[&_.v-timeline-item\_\_body]:!px-6"
              hide-dot
            >
              <section class="flex justify-center py-6 text-xl text-center border-2 border-dashed border-gray-300 text-gray-500 font-light tracking-lighter">
                <section class="flex items-start justify-end flex-auto">
                  <v-icon
                    icon="mdi-arrow-up-left"
                    class="pb-4 text-gray-400"
                  />
                </section>

                <section class="flex flex-col gap-2 flex-initial">
                  <section>Будущие</section>

                  <section class="text-gray-400">
                    <v-icon icon="mdi-calendar-star" />
                  </section>

                  <section>
                    Прошлые
                  </section>
                </section>

                <section class="flex items-end justify-start flex-auto">
                  <v-icon
                    icon="mdi-arrow-down-right"
                    class="pt-4 text-gray-400"
                  />
                </section>

                <section />
              </section>
            </v-timeline-item>
          </template>
        </v-timeline>
      </Container>
    </Viewport>
  </div>

  <CreateBookingForm />
</template>

<script setup lang="ts">
import { computed, onMounted, reactive, ref } from 'vue';

import { BOOKINGS_PAGE_SIZE } from '@/declarations';
import { usePagination, useDateTime } from '@/composables';
import { useBookingsStore } from '@/stores';
import { getNightsCount, getNightsLabel } from '@/utils';

import PageHeader from '@/components/layout/PageHeader.vue';
import Viewport from '@/components/layout/Viewport.vue';
import EmptyState from '@/components/layout/EmptyState.vue';
import Container from '@/components/layout/Container.vue';
import BookingsListSkeleton from '@/components/skeletons/BookingsListSkeleton.vue';
import BookingStatusDisplay from '@/components/content/BookingStatusDisplay.vue';

import CreateBookingForm from './create/CreateBookingForm.vue';
import BookingsFilters from './filters/BookingsFilters.vue';

const pagination = usePagination({ size: BOOKINGS_PAGE_SIZE });

const bookingsStore = useBookingsStore();
const dt = useDateTime();

const isLoading = ref(true);
const isPaginationLoading = ref(false);

const todayMarkIndex = computed(() => {
  return bookingsStore.bookings.findIndex(booking => {
    return Date.now() > Number(new Date(booking.startDate));
  });
});

const appliedFilters = reactive<IBookingFilters>({
  dates: { start: null, end: null },
  property: null,
  guest: null,
  status: null,
});

const getLabeledNightsCount = (booking: IGeneralBooking) => {
  const nightsCount = getNightsCount(booking.startDate, booking.endDate);
  const label = getNightsLabel(nightsCount);

  return `${nightsCount} ${label}`;
};

const fetchData = async (options: Partial<PageFetchDataOptions>) => {
  if (options.useLoading) {
    isLoading.value = true;
  }

  await bookingsStore.fetchData({
    reset: options.reset,
    limit: BOOKINGS_PAGE_SIZE,
    offset: pagination.offset.value,
    dates: appliedFilters.dates,
    property: appliedFilters.property,
    guest: appliedFilters.guest,
    status: appliedFilters.status,
  });

  isLoading.value = false;
};

const onPageRefresh = async () => {
  pagination.resetPage();
  await fetchData({ reset: true, useLoading: true });
};

const onFullyScrolled = async () => {
  isPaginationLoading.value = true;

  pagination.nextPage();
  await fetchData({ reset: false, useLoading: false });

  isPaginationLoading.value = false;
};

const onFiltersApply = (filters: IBookingFilters) => {
  appliedFilters.property = filters.property;
  appliedFilters.dates = filters.dates;
  appliedFilters.guest = filters.guest;
  appliedFilters.status = filters.status;

  pagination.resetPage();
  fetchData({ reset: true, useLoading: true });
};

onMounted(() => fetchData({ reset: true, useLoading: true }));
</script>